package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.ExceptionConst.EXCS;

public class GETSTATIC extends FieldInstruction implements PushInstruction, ExceptionThrower {
   GETSTATIC() {
   }

   public GETSTATIC(int index) {
      super((short)178, index);
   }

   public void accept(Visitor v) {
      v.visitStackProducer(this);
      v.visitPushInstruction(this);
      v.visitExceptionThrower(this);
      v.visitTypedInstruction(this);
      v.visitLoadClass(this);
      v.visitCPInstruction(this);
      v.visitFieldOrMethod(this);
      v.visitFieldInstruction(this);
      v.visitGETSTATIC(this);
   }

   public Class<?>[] getExceptions() {
      return ExceptionConst.createExceptions(EXCS.EXCS_FIELD_AND_METHOD_RESOLUTION, new Class[]{ExceptionConst.INCOMPATIBLE_CLASS_CHANGE_ERROR});
   }

   public int produceStack(ConstantPoolGen cpg) {
      return this.getFieldSize(cpg);
   }
}
